#include "stdafx.h"
#include "misc.h"


typedef BOOL ( WINAPI* LPFN_ISWOW64PROCESS )( HANDLE hProcess, PBOOL Wow64Process );
//typedef BOOLEAN ( WINAPI* LPFN_WOW64DISABLEWOW64FFREDIRECTION )( PVOID *OldValue );
//typedef BOOLEAN ( WINAPI* LPFN_WOW64REVERTWOW64FFREDIRECTION )( PVOID OldValue );
typedef BOOLEAN ( WINAPI *LPFN_WOW64ENABLEWOW64FSREDIRECTION )( BOOLEAN Wow64FsEnableRedirection );
LPFN_ISWOW64PROCESS lpfnIsWow64Process;
//LPFN_WOW64DISABLEWOW64FFREDIRECTION lpfnWow64DisableWow64FsRedirection;
//LPFN_WOW64REVERTWOW64FFREDIRECTION lpfnWow64RevertWow64FsRedirection;
LPFN_WOW64ENABLEWOW64FSREDIRECTION lpfnWow64EnableWow64FsRedirection;



BOOL GetFileVersionDW( TCHAR *path, DWORD *value4 )
{
	DWORD	handle;
	DWORD	rlen;
	DWORD	*lang;
	BYTE	*buf;
	UINT	vlen;
	TCHAR	strLang[9];
	TCHAR	strStream[100];
	TCHAR	*strBuf;

	rlen = GetFileVersionInfoSize( path, &handle );
	if ( rlen == 0 ) {
		return FALSE;
	}

	buf = new BYTE[rlen];

	if ( ( path == NULL ) || ( value4 == NULL ) ) {
		return FALSE;
	}

	if ( buf ) {
		GetFileVersionInfo( path, handle, rlen, buf );
		
		if ( VerQueryValue( buf, _T("\\VarFileInfo\\Translation"), (LPVOID*)&lang, &vlen ) ) {
			_stprintf_s( strLang, 9, _T("%04x%04x"), LOWORD(*lang), HIWORD(*lang) );
			_stprintf_s( strStream, 100, _T("\\StringFileInfo\\%s\\ProductVersion"), strLang );
			if ( VerQueryValue( buf, strStream, (LPVOID*)&strBuf, &vlen ) ) {
				if ( _stscanf_s( strBuf, _T("%d.%d.%d.%d"), &value4[0], &value4[1], &value4[2], &value4[3] ) != 4 ) {
					_stscanf_s( strBuf, _T("%d,%d,%d,%d"), &value4[0], &value4[1], &value4[2], &value4[3] );
				}
				delete[] buf;
				return TRUE;
			}
		}

		delete[] buf;
		return FALSE;
	}

	return FALSE;
}


BOOL GetOSType( TYPE_OS *typeOS )
{
	BOOL isWow64;
	OSVERSIONINFO os;


	lpfnIsWow64Process = (LPFN_ISWOW64PROCESS)GetProcAddress( GetModuleHandle( _T("kernel32.dll") ), "IsWow64Process" );
	if ( lpfnIsWow64Process == NULL ) {
		*typeOS = TYPE_XP32;
	}
	else {
		BOOL wow64;

		wow64 = lpfnIsWow64Process( GetCurrentProcess(), &isWow64 );
		if ( wow64 == 0 ) {
			return FALSE;
		}

		os.dwOSVersionInfoSize = sizeof( os );
		GetVersionEx( &os );
		if ( os.dwPlatformId != VER_PLATFORM_WIN32_NT ) {
			return FALSE;
		}
		else if ( ( os.dwMajorVersion == 5 ) && ( os.dwMinorVersion == 0 ) ) {
			return FALSE;
		}
		else if ( ( os.dwMajorVersion == 5 ) && ( os.dwMinorVersion >= 1 ) ) {
			if ( isWow64 ) {
				*typeOS = TYPE_XP64;
			}
			else {
				*typeOS = TYPE_XP32;
			}
		}
		else if ( os.dwMajorVersion == 6 ) {
			if ( isWow64 ) {
				*typeOS = TYPE_LH64;
			}
			else {
				*typeOS = TYPE_LH32;
			}
		}
	}

	return TRUE;
}

BOOL EnableWow64Redirect( BOOL bEnable )
{
	TYPE_OS type;

	GetOSType( &type );
	switch( type )
	{
	case TYPE_XP64:
	case TYPE_LH64:
		lpfnWow64EnableWow64FsRedirection = (LPFN_WOW64ENABLEWOW64FSREDIRECTION)GetProcAddress( GetModuleHandle( _T("kernel32.dll") ), "Wow64EnableWow64FsRedirection" );
		if ( lpfnWow64EnableWow64FsRedirection == NULL ) return FALSE;
		lpfnWow64EnableWow64FsRedirection( bEnable );
		return TRUE;
		break;
	}
	return TRUE;
}
